#Tests for mgdb
#
# @Author: Christopher Brooks
#
# @Version: $Id: mgdb.tcl,v 1.13.4.1 2005/02/14 19:05:35 cxh Exp $
#
# @Copyright (c) 2004-2005 The Regents of the University of California.
# All rights reserved.
#
# Permission is hereby granted, without written agreement and without
# license or royalty fees, to use, copy, modify, and distribute this
# software and its documentation for any purpose, provided that the
# above copyright notice and the following two paragraphs appear in all
# copies of this software and that appropriate acknowledgments are made
# to the research of the Metropolis group.
# 
# IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
# FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
# ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
# THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
# PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
# CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
# ENHANCEMENTS, OR MODIFICATIONS.
#
# 						PT_COPYRIGHT_VERSION_2
# 						COPYRIGHTENDKEY
#######################################################################

# Load up the test definitions.
if {[string compare test [info procs test]] == 1} then {
    source testDefs.tcl
} {}

# Uncomment this to get a full report, or set in your Tcl shell window.
# set VERBOSE 1

set TESTDIR [pwd]
######################################################################
####
#
test mgdb-1.l {verify the version number of the underlying gdb} {
    set results [exec $METRO/bin/mgdb --version]
    set firstLine [string range $results 0 [expr {[string first {Copyright} [split $results]] -2 }]]
    if [regexp { 5.} $firstLine] {
	error "mgdb requires GDB 6.0 or later, you are running $firstLine"
    }
    
} {}

######################################################################
####
#
test mgdb-2.l {Run ../testmgdb} {
    cd ..	
    puts "mgdb-2.l: make started"
    set errMsg {}
    if [catch {exec -stderrok make -k} errMsg] {
	cd test
	error "mgdb-2.l failed: $errMsg"
    }
    puts "mgdb-2.l: make complete"
    set seconds 15
    puts "mgdb-2.l: running test for $seconds seconds"
    if [catch {set results [exec -stderrok \
		[file join $METRO util testsuite run-watchdog] \
				-n $seconds \
				./testmgdb]} errMsg] {
	cd test
	error "mgdb-2.l failed: $errMsg"
    }
    cd $TESTDIR
    list $results
} {{proc     line     event state
-------- -------- ----- -----
Consumer C.mmm:36       RUN  
proc      line      event state  
--------- --------- ----- -------
Consumer  M.mmm:116 begin RUNNING
Producer0 M.mmm:108 begin RUN    
Producer1 M.mmm:108 begin RUN    
proc      line      event state         
--------- --------- ----- --------------
Consumer  M.mmm:118 begin TESTSCHEDULING
Producer0 M.mmm:108 begin RUN           
Producer1 M.mmm:108 begin RUNNING       
proc      line      event state         
--------- --------- ----- --------------
Consumer  M.mmm:118 begin TESTSCHEDULING
Producer0 M.mmm:108 begin RUNNING       
Producer1 M.mmm:110 begin TESTSCHEDULING
proc      line      event state  
--------- --------- ----- -------
Consumer  M.mmm:118 begin RUNNING
Producer0 M.mmm:110 begin DONTRUN
Producer1 M.mmm:110 begin RUN    
proc      line      event state         
--------- --------- ----- --------------
Consumer  M.mmm:122 end   TESTSCHEDULING
Producer0 M.mmm:110 begin DONTRUN       
Producer1 M.mmm:110 begin RUNNING       
-
run-watchdog: Done}}

